/*************************************************************************\
*                  Copyright (C) Jan Murawski, 2012.                      *
*                                                                         *
* This program is free software. You may use, modify, and redistribute it *
* under the terms of the GNU Public License as published                  *
* by the Free Software Foundation, either version 3 or (at your option)   *
* any later version. This program is distributed without any warranty.    *
\*************************************************************************/

#include "Logger.h"

#include <pthread.h>


// default log level
enum Logger::logLevel Logger::level = NORMAL;


void Logger::setLogLevel(enum logLevel newLevel)
{
    level = newLevel;
}

void Logger::error(const char* msg)
{
    perror(msg);
    exit(EXIT_FAILURE);
}

void Logger::log(const char* msg)
{
    log(msg, NORMAL);
}

void Logger::log(const char *msg, enum logLevel suppliedLevel)
{
    if( suppliedLevel > level )
        return;
        
    printf("<%lu> %s", pthread_self(), msg);
    fflush(stdout);
}

