/*************************************************************************\
*                  Copyright (C) Jan Murawski, 2012.                      *
*                                                                         *
* This program is free software. You may use, modify, and redistribute it *
* under the terms of the GNU Public License as published                  *
* by the Free Software Foundation, either version 3 or (at your option)   *
* any later version. This program is distributed without any warranty.    *
\*************************************************************************/

#ifndef NATTRANSLATOR_H
#define	NATTRANSLATOR_H

#include "Thread.h"

#include <list>
#include <cstdlib>
#include <pthread.h>

using namespace std;


class NatTranslator : public Thread
{
public:
    NatTranslator();
    virtual ~NatTranslator();
    static NatTranslator* getTranslator();
    void translateOutgoing(char* buffer);
    int translateIncomingICMP(char* buffer, int nr);
    bool translateIncomingTCP(char* buffer);
    bool translateIncomingUDP(char* buffer);
    
private:
    static NatTranslator *translator;
    virtual void execute();
    
    pthread_mutex_t cs_mutex;
    
    struct ip_port {
        unsigned long ip;
        unsigned short port;
    };
    
    struct rule {
        int protocol;
        struct ip_port orig_src;
        struct ip_port src;
        struct ip_port dst;
        time_t lastUsed;
        int sockfd;
    };
    
    list<rule*> rules;
    

};

#endif	/* NATTRANSLATOR_H */

