/*************************************************************************\
*                  Copyright (C) Jan Murawski, 2012.                      *
*                                                                         *
* This program is free software. You may use, modify, and redistribute it *
* under the terms of the GNU Public License as published                  *
* by the Free Software Foundation, either version 3 or (at your option)   *
* any later version. This program is distributed without any warranty.    *
\*************************************************************************/

#include "Thread.h"


Thread::Thread()
{
    thread = 0;
}

void Thread::start()
{
   pthread_create(&thread, NULL, Thread::entry, this);
}

void Thread::start_unattanded()
{
   pthread_create(&thread, NULL, Thread::entry_unattanded, this);
}

void* Thread::entry(void* p)
{
   reinterpret_cast<Thread*>(p)->do_start();
}

void* Thread::entry_unattanded(void* p)
{
   reinterpret_cast<Thread*>(p)->do_start();
   delete reinterpret_cast<Thread*>(p);
}

void* Thread::do_start()
{
    execute();
}


void Thread::wait()
{
    if( thread != 0 )
    {
        //pthread_join(thread, (void**) &res); 
        pthread_join(thread, NULL); 
    }
}
