/*************************************************************************\
*                  Copyright (C) Jan Murawski, 2012.                      *
*                                                                         *
* This program is free software. You may use, modify, and redistribute it *
* under the terms of the GNU Public License as published                  *
* by the Free Software Foundation, either version 3 or (at your option)   *
* any later version. This program is distributed without any warranty.    *
\*************************************************************************/

#ifndef TUNNELCLIENT_H
#define	TUNNELCLIENT_H

#include "Thread.h"
#include "Logger.h"
#include "helper.h"

#define _LOCAL_SUBNET_MIN_ _IP_ADDR_(10,1,1,1)
#define _LOCAL_SUBNET_MAX_ _IP_ADDR_(10,1,1,254)

#define _ALLOWED_CLIENTS_COUNT_ 5
#define _ALLOWED_CLIENTS_ { \
        _IP_ADDR_(10,1,1,10), \
        _IP_ADDR_(10,1,1,28), \
        _IP_ADDR_(10,1,1,40), \
        _IP_ADDR_(10,1,1,107), \
        _IP_ADDR_(10,1,1,108) }

#define _DIRECT_COUNT_ 2
#define _DIRECT_IPS_ { \
        _IP_ADDR_(134,147,64,47), \
        _IP_ADDR_(134,147,64,48) }
        //_IP_ADDR_(64,12,73,163), \
        //_IP_ADDR_(64,12,68,229), \
        //_IP_ADDR_(205,188,11,71) }


class TunnelClient : public Thread
{
public:
    TunnelClient();
    virtual ~TunnelClient();
private:
    int tunnelSock;
    int rawSockIn;
    int rawSockOut;
    
protected:
    virtual void execute();

};

#endif	/* TUNNELCLIENT_H */

