/*************************************************************************\
*                  Copyright (C) Jan Murawski, 2012.                      *
*                                                                         *
* This program is free software. You may use, modify, and redistribute it *
* under the terms of the GNU Public License as published                  *
* by the Free Software Foundation, either version 3 or (at your option)   *
* any later version. This program is distributed without any warranty.    *
\*************************************************************************/

#ifndef HELPER_H
#define	HELPER_H

#include <sys/ioctl.h>
#include <stddef.h>
#include <poll.h>
#include <stdlib.h>
#include <stdio.h>
#include <inttypes.h>
#include <arpa/inet.h>
#include <linux/udp.h>


long bytes_on_socket(int socket);
bool socket_is_closed(int sock);
bool basic_header_fields_valild(char* bufferRaw, int bytesRead);

typedef unsigned short u16;
typedef unsigned long u32;
long get_tcp_checksum(struct iphdr * myip, struct tcphdr * mytcp);
long get_udp_checksum(struct iphdr * myip, struct udphdr * udp) ;

#define _IP_ADDR_(c1,c2,c3,c4) (((unsigned long)(c1<<24)+ \
        (unsigned long)(c2<<16)+ \
        (unsigned long)(c3<<8)+ \
        (unsigned long)c4) & 0xffffffff )

#endif	/* HELPER_H */

