/*************************************************************************\
*                  Copyright (C) Jan Murawski, 2012.                      *
*                                                                         *
* This program is free software. You may use, modify, and redistribute it *
* under the terms of the GNU Public License as published                  *
* by the Free Software Foundation, either version 3 or (at your option)   *
* any later version. This program is distributed without any warranty.    *
\*************************************************************************/

#include <cstdlib>
#include <unistd.h>
#include <string.h>

using namespace std;

#include "tunnelServer.h"
#include "TunnelClient.h"
#include "Logger.h"

bool iAmClient = false;
bool iAmServer = false;

void initThreads()
{
    //  iptables -A FORWARD -i eth1 --src 10.1.1.108 -j DROP
    //  iptables -A OUTPUT -p tcp --tcp-flags RST RST -j DROP
    
    TunnelServer *ptr_ts = 0;
    TunnelClient *ptr_tc = 0;
    
    if( iAmServer )
    {
        Logger::log("Running as server...\n");
        ptr_ts = new TunnelServer();
    }
    if( iAmClient )
    {
        Logger::log("Running as client...\n");
        ptr_tc = new TunnelClient();
    }
    
    if( iAmServer )
    {
        ptr_ts->wait();
        delete ptr_ts;
    }
    if( iAmClient )
    {
        ptr_tc->wait();
        delete ptr_tc;
    }
    
}


void parse_args(int argc, char** argv) 
{
    for(int i = 0; i<argc; i++)
    {
        if(strcmp("s", *(argv+i)) == 0)
            iAmServer = true;
        
        if(strcmp("c", *(argv+i)) == 0)
            iAmClient = true;
        
        if(strcmp("verbose", *(argv+i)) == 0)
        {
            Logger::setLogLevel( Logger::VERBOSE );
            Logger::log( "Verbose Logging enabled.\n");
        }
            
    }
    
    //iAmClient = true;
    //iAmServer = false;
}

int main(int argc, char** argv) 
{
    if (getuid() != 0)
        Logger::error("ERROR: root privelidges needed");
    
    parse_args(argc, argv);
    
    system("iptables -A OUTPUT -p tcp --tcp-flags RST RST -j DROP");
    
    initThreads();
    
    return 0;
}

